//+------------------------------------------------------------------+
//|                  MTF_Ichimoku_v1DarkS.mq4                     ik |                
//|                                  Copyright  2007, Forex-TSD.com |
//| KijunLShift TenkanLShift KijunTenkanShift SenkouSpanShift ChinkouSpanShift Price                                        |
//|   leyers  ;  KijunA (if=senkou)_Shift"0"-leading kumo KijunALShift                        
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Maroon
#property indicator_color2 Blue 
#property indicator_color3 DarkSlateBlue
#property indicator_color4 Purple
#property indicator_color5 DarkGreen
#property indicator_color6 Indigo
#property indicator_color7 DarkSlateBlue
#property indicator_color8 DarkSlateGray  

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width6 0

#property indicator_style3 2
#property indicator_style4 0
#property indicator_style6 0
#property indicator_style7 0
//---- input parameters
extern int TimeFrame=0;
extern int Tenkan=9;
extern int Kijun=26;
extern int Senkou=52;
extern int KijunA=52;   //if=52 -leading kumo
extern int TenkanLShift=1;   //linear shift
extern int KijunLShift=2;
extern int KTShift=0;
extern int KijunALShift=3;
extern int SenkouSpanShift=0;
extern int ChinkouSpanShift=0;
extern int ____;
extern int ColorBuffers_Next_Tab;
extern int _________;
extern int Tenkan__________Maroon___0; 
extern int Kijun____________Blue_____1;
extern int SenkouSpanA__DarkSlateBlue_2;
extern int SenkouSpanA2_Purple____3;
extern int Chinkou______DarkGreen_4;
extern int SenkouSpanB__Indigo____5;
extern int SenkouSpanB2_DarkSlateBlue_6;
extern int KijunA___DarkSlateGray_7;


//---- buffers
double Tenkan_Buffer[];
double Kijun_Buffer[];
double Chinkou_Buffer[];
double SpanA_Buffer[];
double SpanB_Buffer[];
double SpanA2_Buffer[];
double SpanB2_Buffer[];
double KijunA_Buffer[];


int a_begin;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
    if(TimeFrame==0) TimeFrame = Period();
//----
   SetIndexStyle(0,DRAW_LINE,0,2);
   SetIndexBuffer(0,Tenkan_Buffer);
   SetIndexDrawBegin(0,Tenkan-1);
   SetIndexShift(0,(KTShift+TenkanLShift)*TimeFrame/Period());
   SetIndexLabel(0,"TenkanSen "+Tenkan+"TF"+TimeFrame+"Ts"+TenkanLShift+"kts"+KTShift+"");   
//----
   SetIndexStyle(1,DRAW_LINE,0,2);
   SetIndexBuffer(1,Kijun_Buffer);
   SetIndexDrawBegin(1,Kijun-1);
   SetIndexShift(1,(KTShift+KijunLShift)*TimeFrame/Period());
   SetIndexLabel(1,"KijunSen "+Kijun+"TF"+TimeFrame+"Ks"+KijunLShift+"kts"+KTShift+"");
//----
   a_begin=Kijun; if(a_begin<Tenkan) a_begin=Tenkan;
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_DOT);
   SetIndexBuffer(2,SpanA_Buffer);
   SetIndexDrawBegin(2,Kijun+a_begin-1);
   if(TimeFrame==0) TimeFrame = Period();
   SetIndexShift(2,Kijun*TimeFrame/Period()-SenkouSpanShift*TimeFrame/Period());
  SetIndexLabel(2,NULL+1);
//  SetIndexLabel(2,"Senkou Kumo TF"+TimeFrame+"S"+(Kijun-SenkouSpanShift)+"(K-ss)"+Kijun+"-"+SenkouSpanShift+"");

//
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,SpanA2_Buffer);
   SetIndexDrawBegin(5,Kijun+a_begin);
   SetIndexShift(5,Kijun*TimeFrame/Period()-SenkouSpanShift*TimeFrame/Period());
   SetIndexLabel(5,"SenkouSpanA (K+T/2)="+(Kijun+Tenkan)/2+"TF"+TimeFrame+"S(K-ss)="+(Kijun-SenkouSpanShift)+"");

//----
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_DOT);
   SetIndexBuffer(3,SpanB_Buffer);
   SetIndexDrawBegin(3,Kijun+Senkou-1);
   SetIndexShift(3,Kijun*TimeFrame/Period()-SenkouSpanShift*TimeFrame/Period());
   SetIndexLabel(3,NULL);
 //  SetIndexLabel(3,"Senkou Kumo TF"+TimeFrame+"S"+(Kijun-SenkouSpanShift)+"(K-ss)"+Kijun+"-"+SenkouSpanShift+"");
//
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,SpanB2_Buffer);
   SetIndexDrawBegin(6,Kijun+Senkou-1);
   SetIndexShift(6,Kijun*TimeFrame/Period()-SenkouSpanShift*TimeFrame/Period());
   SetIndexLabel(6,"SenkouSpanB "+Senkou+"TF"+TimeFrame+"S(K-ss)="+(Kijun-SenkouSpanShift)+"("+Kijun+"-"+SenkouSpanShift+")");

//----
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,Chinkou_Buffer);
   SetIndexShift(4,-Kijun*TimeFrame/Period()+ChinkouSpanShift*TimeFrame/Period());
   SetIndexLabel(4,"ChinkouSpan TF"+TimeFrame+"cs"+ChinkouSpanShift+"");


//----
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,KijunA_Buffer);
   SetIndexDrawBegin(7,KijunA-1);
   SetIndexShift(7,(KijunALShift)*TimeFrame/Period());
   SetIndexLabel(7,"KijunA"+KijunA+"TF"+TimeFrame+"KAs"+KijunALShift+"");


   IndicatorShortName("MTF_Ichimoku_v1DarkS");
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   datetime TimeArray[];
   int i,limit,y=0,counted_bars=IndicatorCounted();

   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame);

   limit=Bars-counted_bars+TimeFrame/Period();
   
   for(i=0,y=0;i<limit;i++) 
   {
   if (Time[i]<TimeArray[y]) y++;
   double UpTenkan = iHigh(NULL,TimeFrame,iHighest(NULL,TimeFrame,MODE_HIGH,Tenkan,y));
   double DnTenkan =  iLow(NULL,TimeFrame, iLowest(NULL,TimeFrame,MODE_LOW ,Tenkan,y));
   Tenkan_Buffer[i] = 0.5*(UpTenkan + DnTenkan);

   double UpKijun = iHigh(NULL,TimeFrame,iHighest(NULL,TimeFrame,MODE_HIGH,Kijun,y));
   double DnKijun =  iLow(NULL,TimeFrame, iLowest(NULL,TimeFrame,MODE_LOW ,Kijun,y));
   Kijun_Buffer[i] = 0.5*(UpKijun + DnKijun);
   
   double UpKijunA = iHigh(NULL,TimeFrame,iHighest(NULL,TimeFrame,MODE_HIGH,KijunA,y));
   double DnKijunA =  iLow(NULL,TimeFrame, iLowest(NULL,TimeFrame,MODE_LOW ,KijunA,y));
   KijunA_Buffer[i] = 0.5*(UpKijunA + DnKijunA);

   
   
   double UpSenkou = iHigh(NULL,TimeFrame,iHighest(NULL,TimeFrame,MODE_HIGH,Senkou,y));
   double DnSenkou =  iLow(NULL,TimeFrame, iLowest(NULL,TimeFrame,MODE_LOW ,Senkou,y));
         
   SpanA_Buffer[i]= 0.5*(Kijun_Buffer[i]+Tenkan_Buffer[i]);
   SpanB_Buffer[i]= 0.5*(UpSenkou + DnSenkou);
   
   double chinkou=iClose(NULL,TimeFrame,y);
   if(chinkou>0) Chinkou_Buffer[i]=chinkou;
   
   SpanA2_Buffer[i]= SpanA_Buffer[i];
   SpanB2_Buffer[i]= SpanB_Buffer[i];
   }
return(0);
}